<script lang="ts">
  import {
    isAuthenticated,
    kanbanShortId,
    kanbans,
    loginWithPopup,
    logout,
    user,
    userId,
  } from 'stores/authStore';
  import LogoutIcon from 'icons/LogoutIcon';
  import {
    mutation,
    operationStore,
    query,
  } from '@urql/svelte';
  import {
    CreateUserDocument,
    type CreateUserMutation,
    type CreateUserMutationVariables,
    UserDocument,
    type UserQuery,
    type UserQueryVariables,
  } from 'generated/graphql';
  import userDataToMutation from 'utils/userDataToMutation';

  const createUserMutation = mutation<CreateUserMutation, CreateUserMutationVariables>({ query: CreateUserDocument });
  const userQuery = operationStore<UserQuery, UserQueryVariables>(UserDocument, undefined, { pause: true });
  query(userQuery);

  const handleSignIn = async () => {
    const userData = await loginWithPopup();
    const createUserRes = await createUserMutation(userDataToMutation(userData));
    if (createUserRes.error) console.error(createUserRes.error);
  };

  $: if ($userId) {
    $userQuery.context.pause = false;
    $userQuery.variables = { userId: $userId };
  }

  $: if ($kanbanShortId && $userId && !$userQuery.fetching && !$kanbans) {
    $userQuery.reexecute({ requestPolicy: 'network-only' });
  }

  $: {
    $kanbans = $userQuery.data?.user?.kanbans;
  }

  const handleLogout = () => logout();
</script>

{#if $isAuthenticated}
  <span class="dark:text-white">{$user?.nickname}</span>
  <button
    on:click={handleLogout}
    class="text-gray-500 dark:text-gray-400 hover:text-black hover:dark:text-white hover:bg-gray-200 dark:hover:bg-gray-700
    dark:focus:ring-gray-700 rounded-lg text-sm p-2"
  >
    <LogoutIcon />
  </button>
{:else}
  <button
    on:click={handleSignIn}
    class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium
      rounded-lg text-sm px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800 {$$props.class}"
  >
    Sign in
  </button>
{/if}